<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "https://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" lang="en-US">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=11"/>
<meta name="generator" content="Doxygen 1.12.0"/>
<meta name="viewport" content="width=device-width, initial-scale=1"/>
<title>kmTimersCommon: ReadMe</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<script type="text/javascript" src="clipboard.js"></script>
<link href="navtree.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="navtreedata.js"></script>
<script type="text/javascript" src="navtree.js"></script>
<script type="text/javascript" src="resize.js"></script>
<script type="text/javascript" src="cookie.js"></script>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="search/searchdata.js"></script>
<script type="text/javascript" src="search/search.js"></script>
<link href="doxygen.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr id="projectrow">
  <td id="projectalign">
   <div id="projectname">kmTimersCommon
   </div>
   <div id="projectbrief">kmTimersCommon library for AVR</div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.12.0 -->
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:d3d9a9a6595521f9666a5e94cc830dab83b65699&amp;dn=expat.txt MIT */
var searchBox = new SearchBox("searchBox", "search/",'.html');
/* @license-end */
</script>
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:d3d9a9a6595521f9666a5e94cc830dab83b65699&amp;dn=expat.txt MIT */
$(function() { codefold.init(0); });
/* @license-end */
</script>
<script type="text/javascript" src="menudata.js"></script>
<script type="text/javascript" src="menu.js"></script>
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:d3d9a9a6595521f9666a5e94cc830dab83b65699&amp;dn=expat.txt MIT */
$(function() {
  initMenu('',true,false,'search.php','Search',true);
  $(function() { init_search(); });
});
/* @license-end */
</script>
<div id="main-nav"></div>
</div><!-- top -->
<div id="side-nav" class="ui-resizable side-nav-resizable">
  <div id="nav-tree">
    <div id="nav-tree-contents">
      <div id="nav-sync" class="sync"></div>
    </div>
  </div>
  <div id="splitbar" style="-moz-user-select:none;" 
       class="ui-resizable-handle">
  </div>
</div>
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:d3d9a9a6595521f9666a5e94cc830dab83b65699&amp;dn=expat.txt MIT */
$(function(){initNavTree('md__x_1_2_r_e_a_d_m_e.html',''); initResizable(true); });
/* @license-end */
</script>
<div id="doc-content">
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
</div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<div id="MSearchResults">
<div class="SRPage">
<div id="SRIndex">
<div id="SRResults"></div>
<div class="SRStatus" id="Loading">Loading...</div>
<div class="SRStatus" id="Searching">Searching...</div>
<div class="SRStatus" id="NoMatches">No Matches</div>
</div>
</div>
</div>
</div>

<div><div class="header">
  <div class="headertitle"><div class="title">ReadMe</div></div>
</div><!--header-->
<div class="contents">
<div class="textblock"><h1>kmTimersCommon library for AVR MCUs</h1>
<p>This AVR MCU library provides common definitions and configurations for up to 6 hardware timers (depends on the MCU capability), essential for precise timing and PWM generation. It offers seamless integration with AVR microcontrollers, allowing developers to efficiently manage timer functionalities.</p>
<h2>Table of Contents</h2>
<ul>
<li>Version History</li>
<li>Overview</li>
<li>Dependencies</li>
<li>Usage</li>
<li>Example Code</li>
<li>Author and License</li>
</ul>
<h2>Version History</h2>
<p>v1.0.0 Initial (2024-05-25)</p>
<h2>Overview</h2>
<p>This library, designed for AVR MCUs, facilitates timer setup and operation, crucial for various tasks like timekeeping, event triggering, and PWM generation. It offers a comprehensive set of definitions and configurations for up to 6 hardware timers (depends on the MCU capability), enabling developers to optimize timing-related tasks efficiently.</p>
<h2>Dependencies</h2>
<ul>
<li><a href="https://gitlab.com/c-mos/kmAvrLibs/kmCommon">kmCommon</a></li>
</ul>
<h2>Usage</h2>
<p>Getting this library and adding it to own project:</p><ul>
<li>To add this module to own project as submodule - enter the main directory of the source code and use git command</li>
</ul>
<div class="fragment"><div class="line"> bash</div>
<div class="line">git submodule add git@gitlab.com:c-mos/kmAvrLibs/kmTimersCommon.git kmTimersCommon</div>
</div><!-- fragment --><ul>
<li>After cloning own application from git repository use following additional git command to get correct revision of submodule: <div class="fragment"><div class="line"> bash</div>
<div class="line">git submodule update --init</div>
</div><!-- fragment --></li>
<li>Include the library headers in your AVR MCU project.</li>
<li>Configure the desired timer(s) by setting appropriate modes and prescaler values.</li>
<li>Optionally, set up output compare registers (OCR) for PWM generation or input capture for precise event timing.</li>
<li>Enable timer interrupts if needed for tasks such as overflow detection or compare match events.</li>
<li>Implement your application logic within the main loop, utilizing the timer functionality as required.</li>
</ul>
<h2>Example Code</h2>
<div class="fragment"><div class="line"><span class="preprocessor">#include &quot;<a class="code" href="km_timer_defs_8h.html">kmTimerDefs.h</a>&quot;</span></div>
<div class="line"> </div>
<div class="line"><span class="keywordtype">int</span> main() {</div>
<div class="line">    <span class="comment">// Configure Timer0 for PWM generation</span></div>
<div class="line">    <span class="comment">// Set mode to Fast PWM with OCR0A as top</span></div>
<div class="line">    TCCR0A |= <a class="code hl_define" href="km_timer0_defs_8h.html#ad618ab7b71aab3219f052fe50d3ce63e">KM_TCC0_MODE_7_A</a>;</div>
<div class="line">    TCCR0B |= <a class="code hl_define" href="km_timer0_defs_8h.html#a43580016f729999bfaefeb721b9757ca">KM_TCC0_PRSC_256</a>; <span class="comment">// Set prescaler to 256</span></div>
<div class="line">    OCR0A = 128; <span class="comment">// Set PWM duty cycle</span></div>
<div class="line"> </div>
<div class="line">    <span class="comment">// Enable Timer0 overflow interrupt</span></div>
<div class="line">    TIMSK0 |= (1 &lt;&lt; TOIE0);</div>
<div class="line"> </div>
<div class="line">    <span class="comment">// Main loop</span></div>
<div class="line">    <span class="keywordflow">while</span> (1) {</div>
<div class="line">        <span class="comment">// Your application logic here</span></div>
<div class="line">    }</div>
<div class="line"> </div>
<div class="line">    <span class="keywordflow">return</span> 0;</div>
<div class="line">}</div>
<div class="ttc" id="akm_timer0_defs_8h_html_a43580016f729999bfaefeb721b9757ca"><div class="ttname"><a href="km_timer0_defs_8h.html#a43580016f729999bfaefeb721b9757ca">KM_TCC0_PRSC_256</a></div><div class="ttdeci">#define KM_TCC0_PRSC_256</div><div class="ttdoc">Clock select of Timer0 - Prescaler 1 / 256.</div><div class="ttdef"><b>Definition</b> kmTimer0Defs.h:87</div></div>
<div class="ttc" id="akm_timer0_defs_8h_html_ad618ab7b71aab3219f052fe50d3ce63e"><div class="ttname"><a href="km_timer0_defs_8h.html#ad618ab7b71aab3219f052fe50d3ce63e">KM_TCC0_MODE_7_A</a></div><div class="ttdeci">#define KM_TCC0_MODE_7_A</div><div class="ttdoc">Timer0 mode 7 (reg. A) - Fast PWM with OCR0A as top.</div><div class="ttdef"><b>Definition</b> kmTimer0Defs.h:125</div></div>
<div class="ttc" id="akm_timer_defs_8h_html"><div class="ttname"><a href="km_timer_defs_8h.html">kmTimerDefs.h</a></div></div>
</div><!-- fragment --><h2>Author and License</h2>
<p>Author: Krzysztof Moskwa</p>
<p>e-mail: chris[dot]moskva[at]gmail[dot]com</p>
<p>Software License: GNU General Public License (GPL) version 3.0 or later. See <a href="https://www.gnu.org/licenses/gpl-3.0.txt">LICENSE.txt</a></p>
<p><img src="https://www.gnu.org/graphics/gplv3-or-later-sm.png" alt="GPL3 Logo" class="inline"/> </p>
</div></div><!-- contents -->
</div><!-- PageDoc -->
</div><!-- doc-content -->
<!-- start footer part -->
<div id="nav-path" class="navpath"><!-- id is needed for treeview function! -->
  <ul>
    <li class="footer">Generated by <a href="https://www.doxygen.org/index.html"><img class="footer" src="doxygen.svg" width="104" height="31" alt="doxygen"/></a> 1.12.0 </li>
  </ul>
</div>
</body>
</html>
